Feature: First Sample API Test

  Background:
    * url baseURL
    * header Accept = 'application/json'
    * def req_payload = read('request.json')

  @nazoor
  Scenario: First Get Call
    Given path '/users?page=2'
    When method GET
    Then status 200

  @nazoor
  Scenario: Demo Get call 1
    Given path '/users'
    When param page = 2
    When method GET
    Then status 200
    And print response
    And print responseHeaders
    And print responseStatus
    And print responseTime


  Scenario: Demo Get Call 2
    Given path '/users'
    When param page = 2
    When method GET
    Then status 200
    And print response
    Then assert response.data[0].first_name == 'Michael'
    Then match response.data[0].first_name == 'Michaelq'

  Scenario: Demo Post Call 1
    Given path '/users'
    And request {"name": "nazoor","job": "leader"}
    When method POST
    Then status 201
    Then print response
    And match response == { "name": "nazoor","job": "leader","id": "#string","createdAt": "#ignore"}

  Scenario: Demo Post Call 2
    Given path '/users'
    And request req_payload
    When method POST
    Then status 201
    Then print response
    And def exp_payload = karate.properties['user.dir']+'/src/test/resources/ExpectedOutput.json'
    And print 'paht = '+exp_payload
    And def exp = read('file:'+exp_payload)
    And print exp
    And match response == exp

  Scenario: Demo Put Call 1
    Given path '/users/2'
    And request req_payload
    When method PUT
    And print response
    Then status 200

  Scenario: Demo Patch Call 2
    Given path '/users/2'
    And request req_payload
    When method PATCH
    And print response
    Then status 200


  Scenario: Demo Delete Call 1
    Given path '/users/2'
    When method DELETE
    And print response
    Then status 204


  Scenario: Demo Karate Config file
    Given print name
    When print baseURL
    When print baseURL

